// SDIFrame.h

#pragma once
#ifndef INC_SDIFRAME
#define INC_SDIFRAME

/////////////////////////////////////////////////////////////////////////////
// This is the View parented by the Frame

class CMyView: public CViewWindowImpl<CMyView>
{
public:
	typedef CViewWindowImpl<CMyView> baseClass;

	BEGIN_MSG_MAP(CMyView)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_SIZE, OnSize)		
		MESSAGE_HANDLER(WM_ERASEBKGND, OnErase)		
		CHAIN_MSG_MAP(baseClass)
	END_MSG_MAP()

    LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		m_wndBrowser.Create(m_hWnd,CWindow::rcDefault,_T("http://www.sellsbrothers.com/attila"),
						WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_HSCROLL, WS_EX_CLIENTEDGE);
		return 0L;
	}

	LRESULT OnErase(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		return 1;
	}
	
	LRESULT OnSize(UINT  uMsg , WPARAM  wParam , LPARAM  lParam , BOOL&  bHandled)
	{
		DefWindowProc();
		RECT rc ;GetClientRect(&rc);
		m_wndBrowser.SetWindowPos(0,&rc,SWP_NOZORDER);
		return 0L;
	}

private:
	CAxWindow m_wndBrowser;
};

/////////////////////////////////////////////////////////////////////////////
// This is the App Frame

class CMyMainFrame: public CFrameWindowImpl<CMyMainFrame>
{
public:
	typedef CFrameWindowImpl<CMyMainFrame> baseClass;
	CMyMainFrame() {}

public:
	BEGIN_MSG_MAP(CMyMainFrame)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
		MESSAGE_HANDLER(WM_SIZE, OnSize)		
		COMMAND_ID_HANDLER(ID_FILE_NEW, OnFileNew) 
		COMMAND_ID_HANDLER(ID_APP_EXIT, OnAppExit) 
		COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAbout) 
		CHAIN_MSG_MAP(baseClass)
	END_MSG_MAP()

public://handlers
	HWND Create(HWND hWndParent, RECT& rcPos, LPCTSTR szWindowName = NULL,
			DWORD dwStyle = 0, DWORD dwExStyle = 0,
			UINT nID = 0, LPVOID lpCreateParam = NULL)
	{
		if (GetWndClassInfo().m_lpszOrigName == NULL)
			GetWndClassInfo().m_lpszOrigName = GetWndClassName();
		ATOM atom = GetWndClassInfo().Register(&m_pfnSuperWindowProc);
	
		// HMENU hMenu = LoadMenu(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME));

		dwStyle = GetWndStyle(dwStyle);
		dwExStyle = GetWndExStyle(dwExStyle);

		HWND hWnd = baseClass::Create(hWndParent, rcPos, _T("Multi SDI App - ala IE's Browse in a new window"));//,dwStyle, dwExStyle, (UINT)hMenu,lpCreateParam);
		
		return hWnd;
	}

	LRESULT OnFileNew(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		_Module.CreateNewThread();
		return 0;
	}

    LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		//Create the Statusbar
		m_wndStatusBar.Create(m_hWnd,CWindow::rcDefault);
		
		//Create the View
		m_View.Create(m_hWnd,CWindow::rcDefault);

		//Fill an array of Toolbar buttons
		TBBUTTON tbButtons[] = 
		{
			{ 0,	ID_FILE_NEW,						TBSTATE_ENABLED				,TBSTYLE_BUTTON, 0L, 0},
			{ 1,	ID_FILE_OPEN,						TBSTATE_ENABLED				,TBSTYLE_BUTTON, 0L, 0},
			{ 2,	ID_FILE_SAVE,						TBSTATE_ENABLED				,TBSTYLE_BUTTON, 0L, 0},
			{ 3,	ID_EDIT_CUT,						TBSTATE_ENABLED				,TBSTYLE_BUTTON, 0L, 0},
			{ 4,	ID_EDIT_COPY,						TBSTATE_ENABLED				,TBSTYLE_BUTTON, 0L, 0},
			{ 5,	ID_EDIT_PASTE,						TBSTATE_ENABLED				,TBSTYLE_BUTTON, 0L, 0},
			{ 6,	ID_APP_ABOUT,						TBSTATE_ENABLED				,TBSTYLE_BUTTON, 0L, 0}
		};

		//Create the Toolbar
		//m_wndToolBar.Create(m_hWnd,CWindow::rcDefault,tbButtons,7,IDR_MAINFRAME);
		//Create the Toolpanel
		m_wndToolBar.Create(m_hWnd,CWindow::rcDefault,tbButtons,7,IDR_MAINFRAME,IDR_MAINFRAME);
		
		CComBSTR str;
        GetWindowText(&str);

		TCHAR psz[256];wsprintf(psz,_T(" -- ProcessID= %d, ThreadID= %d"), GetCurrentProcessId(), GetCurrentThreadId());
		str+= T2BSTR(psz);

		USES_CONVERSION;
		SetWindowText(OLE2T(str));
		return 0L;
	}

	LRESULT OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		m_View.SetFocus();
		return 0L;
	}

	LRESULT OnSize(UINT  uMsg , WPARAM  wParam , LPARAM  lParam , BOOL&  bHandled)
	{
		bHandled = ResizeElements();
		return 0L;
	}
	LRESULT OnAppExit(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{	
		DestroyWindow(); //Will make the Frame call PostQuitMessage
		return 0L;
	}
	LRESULT OnAbout(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		CSimpleDialog<IDD_ABOUT> dlg;
		dlg.DoModal();
		return 0L;
	}


public: //virtuals
	BOOL ResizeElements()
	{
		m_wndStatusBar.SendMessage(WM_SIZE);
		RECT rc,rcToolPanel,rcStatus;
		GetClientRect(&rc);
		
		GetClientRect(&rc);
		m_wndToolBar.SetWindowPos(NULL,rc.left, rc.top, rc.right - rc.left,60,SWP_NOZORDER | SWP_NOACTIVATE);
				
		m_wndToolBar.GetWindowRect(&rcToolPanel);
		rc.top +=  (rcToolPanel.bottom - rcToolPanel.top);

		m_wndStatusBar.GetWindowRect(&rcStatus);
		rc.bottom -= (rcStatus.bottom - rcStatus.top);
		
		m_View.SetWindowPos(NULL, rc.left, rc.top,rc.right - rc.left, rc.bottom - rc.top,
							SWP_NOZORDER | SWP_NOACTIVATE);

		return TRUE;
	}

private:
	CMyView				m_View;
	//CToolBar			m_wndToolBar;		
	CCoolToolPanel		m_wndToolBar;
	CStatusBar			m_wndStatusBar;	
};

#endif  // INC_SDIFRAME
