// MyMainFrame.h

#pragma once
#ifndef INC_MYMAINFRAME
#define INC_MYMAINFRAME

#include "resource.h"
#include "AttilaMsgRouting.h"
#include "ViewTextDlg.h"

class CMyFrame;
class CMyView;

/////////////////////////////////////////////////////////////////////////////
// This is the View parented by the Frame

class CMyView: public CViewWindowImpl<CMyView>
{
	TCHAR m_szLabel[256];
	
public:
	typedef CViewWindowImpl<CMyView> baseclass;

	BEGIN_MSG_MAP(CMyView)
		MESSAGE_HANDLER(WM_PAINT, OnPaint)
		COMMAND_ID_HANDLER(ID_TEST_UI_DLG, OnTestUIDlg)	// JMO: Command UI
		COMMAND_ID_HANDLER(ID_EDIT_CUT, OnEditCut)
		COMMAND_ID_HANDLER(ID_EDIT_COPY, OnEditCopy)
		COMMAND_ID_HANDLER(ID_EDIT_PASTE, OnEditPaste)
		COMMAND_UI_HANDLER(ID_EDIT_CUT, OnUpdateEditCut)
		COMMAND_UI_HANDLER(ID_EDIT_COPY, OnUpdateEditCopy)
		COMMAND_UI_HANDLER(ID_EDIT_PASTE, OnUpdateEditPaste)
		CHAIN_MSG_MAP(baseclass)
	END_MSG_MAP()

	void OnUpdateEditCut(UINT nId, CCmdUI* pCmdUI)
	{
		pCmdUI->Enable(lstrlen(m_szLabel) > 0);
	}
	void OnUpdateEditCopy(UINT nId, CCmdUI* pCmdUI)
	{
		pCmdUI->Enable(lstrlen(m_szLabel) > 0);
	}
	void OnUpdateEditPaste(UINT nId, CCmdUI* pCmdUI)
	{
		BOOL bEnable	= FALSE;
		if ( ::OpenClipboard(m_hWnd) )
		{
			bEnable	= ::IsClipboardFormatAvailable(CF_TEXT) || ::IsClipboardFormatAvailable(CF_OEMTEXT);
			::CloseClipboard();
		}
		pCmdUI->Enable(bEnable);
		::InvalidateRect(m_hWnd, NULL, FALSE);
	}
	LRESULT OnEditCut(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if ( ::OpenClipboard(m_hWnd) )
		{
			TCHAR szBuf[256];
			lstrcpy(szBuf, m_szLabel);
			UINT nLen	= lstrlen(szBuf);
			if ( nLen > 254 )
				nLen	= 254;

			szBuf[nLen++]	= NULL;

			HGLOBAL hgMem = nLen > 0 ? ::GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, nLen * sizeof(TCHAR) + sizeof(TCHAR)) : NULL;
			if ( NULL != hgMem )
			{
				LPTSTR pData	= reinterpret_cast<LPTSTR>(::GlobalLock(hgMem));
				lstrcpy(pData, szBuf);
				::GlobalUnlock(hgMem);
			}
			::SetClipboardData(CF_TEXT, hgMem);
			::CloseClipboard();
			::GlobalFree(hgMem);
			*m_szLabel	= NULL;
			::InvalidateRect(m_hWnd, NULL, TRUE);
		}
		else
		{
			::MessageBeep(MB_ICONEXCLAMATION);
		}
		return 0;
	}
	LRESULT OnEditCopy(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if ( ::OpenClipboard(m_hWnd) )
		{
			TCHAR szBuf[256];
			lstrcpy(szBuf, m_szLabel);
			UINT nLen	= lstrlen(szBuf);
			if ( nLen > 254 )
				nLen	= 254;

			szBuf[nLen++]	= NULL;

			HGLOBAL hgMem = nLen > 0 ? ::GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, nLen * sizeof(TCHAR) + sizeof(TCHAR)) : NULL;
			if ( NULL != hgMem )
			{
				LPTSTR pData	= reinterpret_cast<LPTSTR>(::GlobalLock(hgMem));
				lstrcpy(pData, szBuf);
				::GlobalUnlock(hgMem);
			}
			::SetClipboardData(CF_TEXT, hgMem);
			::CloseClipboard();
			::GlobalFree(hgMem);
			::InvalidateRect(m_hWnd, NULL, FALSE);
		}
		else
		{
			::MessageBeep(MB_ICONEXCLAMATION);
		}
		return 0;
	}
	LRESULT OnEditPaste(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if ( ::OpenClipboard(m_hWnd) )
		{
			*m_szLabel	= NULL;
			if ( ::IsClipboardFormatAvailable(CF_TEXT) || ::IsClipboardFormatAvailable(CF_OEMTEXT) )
			{
				HGLOBAL hgMem	= ::GetClipboardData(CF_TEXT);
				LPTSTR pData	= reinterpret_cast<LPTSTR>(::GlobalLock(hgMem));
				if ( NULL != pData )
					lstrcpy(m_szLabel, pData);

				::GlobalUnlock(hgMem);
				::InvalidateRect(m_hWnd, NULL, TRUE);
			}
			::CloseClipboard();
		}
		else
		{
			::MessageBeep(MB_ICONEXCLAMATION);
		}
		return 0;
	}
	CMyView()
	{
		lstrcpy(m_szLabel, _T("Attila : Single Instance App"));
	}
	// Demo a command UI dialog
	LRESULT OnTestUIDlg(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		CViewTextDlg dlg;
		dlg.Init(m_szLabel);
		dlg.DoModal(m_hWnd);
		return 0;
	}
	LRESULT OnPaint(UINT, WPARAM, LPARAM, BOOL&)
    {
        // Paint the window
        PAINTSTRUCT ps;
        HDC         hdc = BeginPaint(&ps);
        
        SetTextColor(hdc, RGB(255,0,0) );

        RECT    rect; GetClientRect(&rect);
        DrawText(hdc, m_szLabel, -1, &rect, DT_SINGLELINE | DT_CENTER | DT_VCENTER);
        
        EndPaint(&ps);
        return 0;
    }
};

/////////////////////////////////////////////////////////////////////////////
// This is the App Frame

class CMyFrame: public CFrameWindowImpl<CMyFrame>
{
public:
	typedef CFrameWindowImpl<CMyFrame> baseClass;
	CMyFrame()
	{
	}

public:
	BEGIN_MSG_MAP(CMyFrame)
		CHAIN_MSG_MAP_MEMBER_FILTER(m_View, WM_CMDUI)				// JMO: added to demo CMDUI
		CHAIN_MSG_MAP_MEMBER_FILTER(m_View, WM_COMMAND)				// JMO: added to demo CMDUI
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
		MESSAGE_HANDLER(WM_SIZE, OnSize)		
		COMMAND_ID_HANDLER(ID_APP_EXIT, OnAppExit) 
		COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAbout) 
		COMMAND_UI_HANDLER(ID_INDICATOR_CAPS, OnUpdateIndicators)	// JMO: added to demo CMDUI
		COMMAND_UI_HANDLER(ID_INDICATOR_NUM, OnUpdateIndicators)	// JMO: added to demo CMDUI
		COMMAND_UI_HANDLER(ID_INDICATOR_SCRL, OnUpdateIndicators)	// JMO: added to demo CMDUI
		COMMAND_UI_HANDLER(ID_TEST_MENU, OnUpdateTestMenu)
		MESSAGE_HANDLER(WM_ENTERIDLE, OnEnterIdle)
		CHAIN_MSG_MAP(baseClass)
	END_MSG_MAP()

public://handlers


	LRESULT OnEnterIdle(UINT, WPARAM wParam, LPARAM lParam, BOOL&)
	{
		// If this is for a dialog box, send an UPDATE command UI message

		if ( MSGF_DIALOGBOX == wParam )
			::SendMessage(reinterpret_cast<HWND>(lParam), WM_IDLECMDUI, 0, 0);

		return 0;
	}
	void OnUpdateTestMenu(UINT nId, CCmdUI* pCmdUI)
	{
		static int nOption	= 0;
		switch ( nOption )
		{
		case 0:
			pCmdUI->Enable(TRUE);
			pCmdUI->SetRadio(FALSE);
			pCmdUI->SetCheck(0);
			pCmdUI->SetText(_T("Every time you popup this menu, this item's state will change to demonstrate command UI in a menu"));
			break;
		case 1:
			pCmdUI->Enable(TRUE);
			pCmdUI->SetRadio(FALSE);
			pCmdUI->SetCheck(0);
			pCmdUI->SetText(_T("Now this item is ENABLED"));
			break;
		case 2:
			pCmdUI->Enable(TRUE);
			pCmdUI->SetCheck(1);
			pCmdUI->SetText(_T("Now this item is ENABLED and CHECKED "));
			break;
		case 3:
			pCmdUI->Enable(TRUE);
			pCmdUI->SetRadio(TRUE);
			pCmdUI->SetText(_T("Now this item is ENABLED and RADIO"));
			break;
		case 4:
			pCmdUI->Enable(FALSE);
			pCmdUI->SetRadio(FALSE);
			pCmdUI->SetCheck(0);
			pCmdUI->SetText(_T("Now this item is DISABLED"));
			break;
		case 5:
			pCmdUI->Enable(FALSE);
			pCmdUI->SetCheck(TRUE);
			pCmdUI->SetText(_T("Now this item is DISABLED and CHECKED"));
			break;
		case 6:
			pCmdUI->Enable(FALSE);
			pCmdUI->SetRadio(TRUE);
			pCmdUI->SetText(_T("Now this item is DISABLED and RADIO"));
			break;
		};
		if ( ++nOption > 6 )
			nOption = 0;

	}

	// JMO: a command ui handler for the various indicator keys.  It pops the
	//      status bar panes in and out depending upon the state of the key.

	void OnUpdateIndicators(UINT nId, CCmdUI* pCmdUI)
	{
		UINT nVK	= 0;
		switch(nId)
		{
		case ID_INDICATOR_CAPS:
			nVK = VK_CAPITAL;
			break;

		case ID_INDICATOR_NUM:
			nVK = VK_NUMLOCK;
			break;

		case ID_INDICATOR_SCRL:
			nVK = VK_SCROLL;
			break;

		default:
			break;
		}
		short nKeyState	= ::GetKeyState(nVK);
		pCmdUI->Enable(0x0001 & nKeyState);
	}
	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		//Create the Statusbar
		m_wndStatusBar.Create(m_hWnd,CWindow::rcDefault);

		// JMO: command ids of buttons
		static UINT indicators[] =
		{
			ID_SEPARATOR,           // status line indicator
			ID_INDICATOR_CAPS,
			ID_INDICATOR_NUM,
			ID_INDICATOR_SCRL
		};
		m_wndStatusBar.SetIndicators(indicators, 4);// JMO: set command ids of buttons
		m_wndStatusBar.SetText(0, _T("Ready"));
		
		//Create the View
		m_View.Create(m_hWnd,CWindow::rcDefault);

		//Fill an array of Toolbar buttons
		TBBUTTON tbButtons[] = 
		{
			{0,	ID_FILE_NEW,	TBSTATE_ENABLED,	TBSTYLE_BUTTON, 0L, 0},
			{1,	ID_FILE_OPEN,	TBSTATE_ENABLED,	TBSTYLE_BUTTON, 0L, 0},
			{2,	ID_FILE_SAVE,	TBSTATE_ENABLED,	TBSTYLE_BUTTON, 0L, 0},
			{3,	ID_EDIT_CUT,	TBSTATE_ENABLED,	TBSTYLE_BUTTON, 0L, 0},
			{4,	ID_EDIT_COPY,	TBSTATE_ENABLED,	TBSTYLE_BUTTON, 0L, 0},
			{5,	ID_EDIT_PASTE,	TBSTATE_ENABLED,	TBSTYLE_BUTTON, 0L, 0},
			{6,	ID_APP_ABOUT,	TBSTATE_ENABLED,	TBSTYLE_BUTTON, 0L, 0},
			{7,	ID_TEST_UI_DLG,	TBSTATE_ENABLED,	TBSTYLE_BUTTON, 0L, 0}	// JMO: added to demo CMDUI	
		};

		//Create the Toolbar
		m_wndToolBar.Create(m_hWnd, CWindow::rcDefault, tbButtons, 8, IDR_MAINFRAME);
		
		return 0L;
	}

	LRESULT OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		m_View.SetFocus();
		return 0L;
	}

	LRESULT OnSize(UINT  uMsg , WPARAM  wParam , LPARAM  lParam , BOOL&  bHandled)
	{
		bHandled = ResizeElements();
		return 0L;
	}

	LRESULT OnAppExit(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{	
		DestroyWindow(); //Will make the Frame call PostQuitMessage
		return 0L;
	}

	LRESULT OnAbout(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		CSimpleDialog<IDD_ABOUT> dlg;
		dlg.DoModal();
		return 0L;
	}

public: //virtuals
	BOOL ResizeElements()
	{
		m_wndStatusBar.SendMessage(WM_SIZE);
		RECT rc,rcToolPanel,rcStatus;
		GetClientRect(&rc);
		
		GetClientRect(&rc);
		m_wndToolBar.SetWindowPos(NULL,rc.left, rc.top, rc.right - rc.left,30,SWP_NOZORDER | SWP_NOACTIVATE);
				
		m_wndToolBar.GetWindowRect(&rcToolPanel);
		rc.top +=  (rcToolPanel.bottom - rcToolPanel.top);

		m_wndStatusBar.GetWindowRect(&rcStatus);
		rc.bottom -= (rcStatus.bottom - rcStatus.top);
		
		m_View.SetWindowPos(NULL, rc.left, rc.top,rc.right - rc.left, rc.bottom - rc.top,
							SWP_NOZORDER | SWP_NOACTIVATE);

		return TRUE;
	}

private:
	CMyView									m_View;

	// JMO: added filtered message paths to demonstrate CMDUI  Lifted from CmdRouteWnd sample

//	CToolBar								m_wndToolBar;	// JMO: not good enough for idle-time command UI		
	CIdleUIToolBar							m_wndToolBar;	// JMO: toolbar that's ready for idle-time command ui
	CCmdUIStatusBar							m_wndStatusBar;	// JMO: status bar that allows assigning cmd ids to panes
};

#endif // INC_MYMAINFRAME
